#include <stdio.h>
#include <stdlib.h>
#include "align.h"

node_info_t node_info_init(void)
{
  node_info_t t;

  if((t = (node_info_t)malloc(sizeof(struct node_info))) == NULL){
    fprintf(stderr, "Can't allocate memory for node-info\n");
    exit(-1);
  }
  t->status = UNVISITED;
  t->edge_heap_size = 0;
  t->edge_heap = NULL;
  t->tree_heap = NULL;
  return t;
}

void node_info_finish(node_info_t node_info)
{
  free(node_info);
}

node_t node_init(int dim, int *pos)
{
  int i;
  node_t t;

  if((t = (node_t)malloc(sizeof(struct node))) == NULL){
    fprintf(stderr, "Can't allocate memory for node\n");
    exit(-1);
  }
  if((t->pos = (int *)malloc(sizeof(int) * dim)) == NULL){
    fprintf(stderr, "Can't allocate memory for node\n");
    exit(-1);
  }
  for(i = 0; i < dim; i++){
    t->pos[i] = pos[i];
  }
  t->info[FORWARD] = NULL;
  t->info[BACKWARD] = NULL;
  return t;
}

void node_finish(node_t node)
{
  free(node->pos);
  if(fs_info(node) != NULL){
    node_info_finish(fs_info(node));
  }
  if(bs_info(node) != NULL){
    node_info_finish(bs_info(node));
  }
  free(node);
}
